#!/usr/bin/env bash

if [ $EUID -gt 0 ]; then
    echo 'Run update.tool as root.'
    exit 1
fi

domain='sabnzbd.domain.com'
apikey='insertsabnzbdapikeyhere'
pool='software'

is_sabnzbd_idle() {
    local result=1
    local status="$(curl -Ls 'https://'$domain'/api?apikey='$apikey'&mode=queue&output=json' | jq -r '.queue.status')"
    if [ "${status,,}" == "idle" ]; then
        result=0
    fi

    return $result
}

mapfile -t apps < <(cli -m csv -c 'app chart_release query name,update_available' | grep true | cut -d ',' -f 1)
if [ ${#apps[@]} -gt 0 ]; then
    for i in "${apps[@]}"; do
        i="${i%%[[:cntrl:]]}"
        echo -n "Updating ${i}... "
        if [ "${i,,}" == "sabnzbd" ]; then
            while true; do
                if is_sabnzbd_idle; then
                    rm -rf /mnt/$pool/opt/downloads/{,in}complete/*
                    break
                fi
                sleep 10
            done
        fi
        cli -c 'app chart_release upgrade release_name="'$i'"' > /dev/null 2>&1
        echo 'OK'
    done
fi
